unit Unit1;

interface

uses
  ShellAPI,
  ComCtrls, StdCtrls, Classes, Controls,
  Windows, Messages, SysUtils, Variants, Graphics, Forms,
  Dialogs, raw_ping, Spin;

type

 ip_option_information = record
  Ttl : byte;
  Tos : byte;
  Flags : byte;
  OptionsSize : byte;
  OptionsData : pointer;
end;

 ICMP_ECHO_REPLY =
 record
      Address : IPAddr;
      Status : ULONG;
      RoundTripTime : ULONG;
      DataSize : Word;
      Reserved : Word;
      Data : Pointer;
      Options : IP_OPTION_INFORMATION;
 end;

 PPingResult = ^TPingResult;
 TPingResult = Record
                 IPAdress:String;
                 Exists:Boolean;
                 RTT:ULONG;
                 Ttl:byte;
               end;


  TPingThread = class(TThread)
  private
    mmResult:TMemo;
  protected
    procedure Execute; override;
    procedure UpdateResult;
  public
    PingResult:TPingResult;
    Ready:Boolean;

    constructor Create(Ping:TPingResult);
  end;

  TForm1 = class(TForm)
    edtHost: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    seNum: TSpinEdit;
    StatusBar1: TStatusBar;
    lblThreads: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
  private
    pt:TPingThread;
    pr:TPingResult;
  public
    { Public declarations }
  end;

const
  CHAR_CRLF = #13#10;

var
  Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.Button1Click(Sender: TObject);
var
  i:Integer;
begin

  ProgressBar1.Max := seNum.Value - 1;

  for i := 0 to (seNum.Value - 1) do begin
    ProgressBar1.Position := i;
    Application.ProcessMessages;

    // Enviar
    pr.IPAdress := edtHost.Text;
    pt := TPingThread.Create(pr);
    pt.mmResult := Memo1;

    // Comenzar
    pt.Resume;

  end;
end;


{ TPingThread }

constructor TPingThread.Create(Ping: TPingResult);
begin
  PingResult.IPAdress := Ping.IPAdress;
  inherited Create(False);
end;

procedure TPingThread.Execute;
var
  Handle : THandle;
  InAddr : IPAddr;
  DW     : DWORD;
  cnt    : integer;
  SAddr  : string;
  pnum   : integer;
  minTime: longint;
  maxTime: longint;
  allTime: longint;
  stat   : longint;
  PingBuf: array[0..31] of char;
  Reply  : ICMP_ECHO_REPLY;
begin

  //more compex way:
  Handle := IcmpCreateFile;
  if Handle = INVALID_HANDLE_VALUE then
   Halt(2);
  TranslateStringToTInAddr(PingResult.IPAdress, InAddr);

  SAddr := PingResult.IPAdress;

  pnum := 0;
  minTime := MaxInt -1;
  maxTime := 0;
  AllTime := 0;

  Reply.Data := @pingBuf;
  Reply.DataSize := 32;


  DW := IcmpSendEcho(Handle, InAddr, @PingBuf, 32, nil, @reply, SizeOf(icmp_echo_reply) + 32 , 3000);
  if DW = 0 then
    // Error
  else  begin
    PingResult.TTL := Reply.Options.Ttl;
    PingResult.RTT := Reply.RoundTripTime;

      stat := Reply.RoundTripTime;
      inc(pnum);
      if minTime > stat then
        minTime := stat;
      if maxTime < stat then
        maxTime := stat;
      AllTime := AllTime + stat;
  end;
  Sleep(500);
  IcmpCloseHandle(Handle);

  PingResult.Exists := not (DW = 0);

  Synchronize(UpdateResult);

end;

procedure TForm1.StatusBar1Click(Sender: TObject);
begin
      ShellExecute(Handle,
             'open',
             'http://neftali-mirror.site11.com/',
             nil,
             nil,
             SW_SHOW);
end;

procedure TPingThread.UpdateResult;
var
  str:string;
begin

  Str := Format('  time=%dms TTL=%d',[PingResult.RTT, PingResult.TTL]);
  mmResult.Lines.Add(Str);

end;

end.
